// Code generated by cdpgen. DO NOT EDIT.

package performancetimeline

import (
	"github.com/mafredri/cdp/protocol/dom"
	"github.com/mafredri/cdp/protocol/network"
	"github.com/mafredri/cdp/protocol/page"
)

// LargestContentfulPaint See https://github.com/WICG/LargestContentfulPaint
// and largest_contentful_paint.idl
type LargestContentfulPaint struct {
	RenderTime network.TimeSinceEpoch `json:"renderTime"`          // No description.
	LoadTime   network.TimeSinceEpoch `json:"loadTime"`            // No description.
	Size       float64                `json:"size"`                // The number of pixels being painted.
	ElementID  *string                `json:"elementId,omitempty"` // The id attribute of the element, if available.
	URL        *string                `json:"url,omitempty"`       // The URL of the image (may be trimmed).
	NodeID     *dom.BackendNodeID     `json:"nodeId,omitempty"`    // No description.
}

// LayoutShiftAttribution
type LayoutShiftAttribution struct {
	PreviousRect dom.Rect           `json:"previousRect"`     // No description.
	CurrentRect  dom.Rect           `json:"currentRect"`      // No description.
	NodeID       *dom.BackendNodeID `json:"nodeId,omitempty"` // No description.
}

// LayoutShift See https://wicg.github.io/layout-instability/#sec-layout-shift
// and layout_shift.idl
type LayoutShift struct {
	Value          float64                  `json:"value"`          // Score increment produced by this event.
	HadRecentInput bool                     `json:"hadRecentInput"` // No description.
	LastInputTime  network.TimeSinceEpoch   `json:"lastInputTime"`  // No description.
	Sources        []LayoutShiftAttribution `json:"sources"`        // No description.
}

// TimelineEvent
type TimelineEvent struct {
	FrameID            page.FrameID            `json:"frameId"`                      // Identifies the frame that this event is related to. Empty for non-frame targets.
	Type               string                  `json:"type"`                         // The event type, as specified in https://w3c.github.io/performance-timeline/#dom-performanceentry-entrytype This determines which of the optional "details" fiedls is present.
	Name               string                  `json:"name"`                         // Name may be empty depending on the type.
	Time               network.TimeSinceEpoch  `json:"time"`                         // Time in seconds since Epoch, monotonically increasing within document lifetime.
	Duration           *float64                `json:"duration,omitempty"`           // Event duration, if applicable.
	LcpDetails         *LargestContentfulPaint `json:"lcpDetails,omitempty"`         // No description.
	LayoutShiftDetails *LayoutShift            `json:"layoutShiftDetails,omitempty"` // No description.
}
