// Code generated by cdpgen. DO NOT EDIT.

package accessibility

import (
	"github.com/mafredri/cdp/protocol/dom"
	"github.com/mafredri/cdp/protocol/page"
	"github.com/mafredri/cdp/protocol/runtime"
)

// GetPartialAXTreeArgs represents the arguments for GetPartialAXTree in the Accessibility domain.
type GetPartialAXTreeArgs struct {
	NodeID         *dom.NodeID             `json:"nodeId,omitempty"`         // Identifier of the node to get the partial accessibility tree for.
	BackendNodeID  *dom.BackendNodeID      `json:"backendNodeId,omitempty"`  // Identifier of the backend node to get the partial accessibility tree for.
	ObjectID       *runtime.RemoteObjectID `json:"objectId,omitempty"`       // JavaScript object id of the node wrapper to get the partial accessibility tree for.
	FetchRelatives *bool                   `json:"fetchRelatives,omitempty"` // Whether to fetch this nodes ancestors, siblings and children. Defaults to true.
}

// NewGetPartialAXTreeArgs initializes GetPartialAXTreeArgs with the required arguments.
func NewGetPartialAXTreeArgs() *GetPartialAXTreeArgs {
	args := new(GetPartialAXTreeArgs)

	return args
}

// SetNodeID sets the NodeID optional argument. Identifier of the node
// to get the partial accessibility tree for.
func (a *GetPartialAXTreeArgs) SetNodeID(nodeID dom.NodeID) *GetPartialAXTreeArgs {
	a.NodeID = &nodeID
	return a
}

// SetBackendNodeID sets the BackendNodeID optional argument.
// Identifier of the backend node to get the partial accessibility tree
// for.
func (a *GetPartialAXTreeArgs) SetBackendNodeID(backendNodeID dom.BackendNodeID) *GetPartialAXTreeArgs {
	a.BackendNodeID = &backendNodeID
	return a
}

// SetObjectID sets the ObjectID optional argument. JavaScript object
// id of the node wrapper to get the partial accessibility tree for.
func (a *GetPartialAXTreeArgs) SetObjectID(objectID runtime.RemoteObjectID) *GetPartialAXTreeArgs {
	a.ObjectID = &objectID
	return a
}

// SetFetchRelatives sets the FetchRelatives optional argument.
// Whether to fetch this nodes ancestors, siblings and children.
// Defaults to true.
func (a *GetPartialAXTreeArgs) SetFetchRelatives(fetchRelatives bool) *GetPartialAXTreeArgs {
	a.FetchRelatives = &fetchRelatives
	return a
}

// GetPartialAXTreeReply represents the return values for GetPartialAXTree in the Accessibility domain.
type GetPartialAXTreeReply struct {
	Nodes []AXNode `json:"nodes"` // The `Accessibility.AXNode` for this DOM node, if it exists, plus its ancestors, siblings and children, if requested.
}

// GetFullAXTreeArgs represents the arguments for GetFullAXTree in the Accessibility domain.
type GetFullAXTreeArgs struct {
	Depth   *int          `json:"depth,omitempty"`   // The maximum depth at which descendants of the root node should be retrieved. If omitted, the full tree is returned.
	FrameID *page.FrameID `json:"frameId,omitempty"` // The frame for whose document the AX tree should be retrieved. If omitted, the root frame is used.
}

// NewGetFullAXTreeArgs initializes GetFullAXTreeArgs with the required arguments.
func NewGetFullAXTreeArgs() *GetFullAXTreeArgs {
	args := new(GetFullAXTreeArgs)

	return args
}

// SetDepth sets the Depth optional argument. The maximum depth at
// which descendants of the root node should be retrieved. If omitted,
// the full tree is returned.
func (a *GetFullAXTreeArgs) SetDepth(depth int) *GetFullAXTreeArgs {
	a.Depth = &depth
	return a
}

// SetFrameID sets the FrameID optional argument. The frame for whose
// document the AX tree should be retrieved. If omitted, the root frame
// is used.
func (a *GetFullAXTreeArgs) SetFrameID(frameID page.FrameID) *GetFullAXTreeArgs {
	a.FrameID = &frameID
	return a
}

// GetFullAXTreeReply represents the return values for GetFullAXTree in the Accessibility domain.
type GetFullAXTreeReply struct {
	Nodes []AXNode `json:"nodes"` // No description.
}

// GetRootAXNodeArgs represents the arguments for GetRootAXNode in the Accessibility domain.
type GetRootAXNodeArgs struct {
	FrameID *page.FrameID `json:"frameId,omitempty"` // The frame in whose document the node resides. If omitted, the root frame is used.
}

// NewGetRootAXNodeArgs initializes GetRootAXNodeArgs with the required arguments.
func NewGetRootAXNodeArgs() *GetRootAXNodeArgs {
	args := new(GetRootAXNodeArgs)

	return args
}

// SetFrameID sets the FrameID optional argument. The frame in whose
// document the node resides. If omitted, the root frame is used.
func (a *GetRootAXNodeArgs) SetFrameID(frameID page.FrameID) *GetRootAXNodeArgs {
	a.FrameID = &frameID
	return a
}

// GetRootAXNodeReply represents the return values for GetRootAXNode in the Accessibility domain.
type GetRootAXNodeReply struct {
	Node AXNode `json:"node"` // No description.
}

// GetAXNodeAndAncestorsArgs represents the arguments for GetAXNodeAndAncestors in the Accessibility domain.
type GetAXNodeAndAncestorsArgs struct {
	NodeID        *dom.NodeID             `json:"nodeId,omitempty"`        // Identifier of the node to get.
	BackendNodeID *dom.BackendNodeID      `json:"backendNodeId,omitempty"` // Identifier of the backend node to get.
	ObjectID      *runtime.RemoteObjectID `json:"objectId,omitempty"`      // JavaScript object id of the node wrapper to get.
}

// NewGetAXNodeAndAncestorsArgs initializes GetAXNodeAndAncestorsArgs with the required arguments.
func NewGetAXNodeAndAncestorsArgs() *GetAXNodeAndAncestorsArgs {
	args := new(GetAXNodeAndAncestorsArgs)

	return args
}

// SetNodeID sets the NodeID optional argument. Identifier of the node
// to get.
func (a *GetAXNodeAndAncestorsArgs) SetNodeID(nodeID dom.NodeID) *GetAXNodeAndAncestorsArgs {
	a.NodeID = &nodeID
	return a
}

// SetBackendNodeID sets the BackendNodeID optional argument.
// Identifier of the backend node to get.
func (a *GetAXNodeAndAncestorsArgs) SetBackendNodeID(backendNodeID dom.BackendNodeID) *GetAXNodeAndAncestorsArgs {
	a.BackendNodeID = &backendNodeID
	return a
}

// SetObjectID sets the ObjectID optional argument. JavaScript object
// id of the node wrapper to get.
func (a *GetAXNodeAndAncestorsArgs) SetObjectID(objectID runtime.RemoteObjectID) *GetAXNodeAndAncestorsArgs {
	a.ObjectID = &objectID
	return a
}

// GetAXNodeAndAncestorsReply represents the return values for GetAXNodeAndAncestors in the Accessibility domain.
type GetAXNodeAndAncestorsReply struct {
	Nodes []AXNode `json:"nodes"` // No description.
}

// GetChildAXNodesArgs represents the arguments for GetChildAXNodes in the Accessibility domain.
type GetChildAXNodesArgs struct {
	ID      AXNodeID      `json:"id"`                // No description.
	FrameID *page.FrameID `json:"frameId,omitempty"` // The frame in whose document the node resides. If omitted, the root frame is used.
}

// NewGetChildAXNodesArgs initializes GetChildAXNodesArgs with the required arguments.
func NewGetChildAXNodesArgs(id AXNodeID) *GetChildAXNodesArgs {
	args := new(GetChildAXNodesArgs)
	args.ID = id
	return args
}

// SetFrameID sets the FrameID optional argument. The frame in whose
// document the node resides. If omitted, the root frame is used.
func (a *GetChildAXNodesArgs) SetFrameID(frameID page.FrameID) *GetChildAXNodesArgs {
	a.FrameID = &frameID
	return a
}

// GetChildAXNodesReply represents the return values for GetChildAXNodes in the Accessibility domain.
type GetChildAXNodesReply struct {
	Nodes []AXNode `json:"nodes"` // No description.
}

// QueryAXTreeArgs represents the arguments for QueryAXTree in the Accessibility domain.
type QueryAXTreeArgs struct {
	NodeID         *dom.NodeID             `json:"nodeId,omitempty"`         // Identifier of the node for the root to query.
	BackendNodeID  *dom.BackendNodeID      `json:"backendNodeId,omitempty"`  // Identifier of the backend node for the root to query.
	ObjectID       *runtime.RemoteObjectID `json:"objectId,omitempty"`       // JavaScript object id of the node wrapper for the root to query.
	AccessibleName *string                 `json:"accessibleName,omitempty"` // Find nodes with this computed name.
	Role           *string                 `json:"role,omitempty"`           // Find nodes with this computed role.
}

// NewQueryAXTreeArgs initializes QueryAXTreeArgs with the required arguments.
func NewQueryAXTreeArgs() *QueryAXTreeArgs {
	args := new(QueryAXTreeArgs)

	return args
}

// SetNodeID sets the NodeID optional argument. Identifier of the node
// for the root to query.
func (a *QueryAXTreeArgs) SetNodeID(nodeID dom.NodeID) *QueryAXTreeArgs {
	a.NodeID = &nodeID
	return a
}

// SetBackendNodeID sets the BackendNodeID optional argument.
// Identifier of the backend node for the root to query.
func (a *QueryAXTreeArgs) SetBackendNodeID(backendNodeID dom.BackendNodeID) *QueryAXTreeArgs {
	a.BackendNodeID = &backendNodeID
	return a
}

// SetObjectID sets the ObjectID optional argument. JavaScript object
// id of the node wrapper for the root to query.
func (a *QueryAXTreeArgs) SetObjectID(objectID runtime.RemoteObjectID) *QueryAXTreeArgs {
	a.ObjectID = &objectID
	return a
}

// SetAccessibleName sets the AccessibleName optional argument. Find
// nodes with this computed name.
func (a *QueryAXTreeArgs) SetAccessibleName(accessibleName string) *QueryAXTreeArgs {
	a.AccessibleName = &accessibleName
	return a
}

// SetRole sets the Role optional argument. Find nodes with this
// computed role.
func (a *QueryAXTreeArgs) SetRole(role string) *QueryAXTreeArgs {
	a.Role = &role
	return a
}

// QueryAXTreeReply represents the return values for QueryAXTree in the Accessibility domain.
type QueryAXTreeReply struct {
	Nodes []AXNode `json:"nodes"` // A list of `Accessibility.AXNode` matching the specified attributes, including nodes that are ignored for accessibility.
}
