// Code generated by cdpgen. DO NOT EDIT.

package target

import (
	"github.com/mafredri/cdp/protocol/internal"
)

// ActivateTargetArgs represents the arguments for ActivateTarget in the Target domain.
type ActivateTargetArgs struct {
	TargetID ID `json:"targetId"` // No description.
}

// NewActivateTargetArgs initializes ActivateTargetArgs with the required arguments.
func NewActivateTargetArgs(targetID ID) *ActivateTargetArgs {
	args := new(ActivateTargetArgs)
	args.TargetID = targetID
	return args
}

// AttachToTargetArgs represents the arguments for AttachToTarget in the Target domain.
type AttachToTargetArgs struct {
	TargetID ID    `json:"targetId"`          // No description.
	Flatten  *bool `json:"flatten,omitempty"` // Enables "flat" access to the session via specifying sessionId attribute in the commands. We plan to make this the default, deprecate non-flattened mode, and eventually retire it. See crbug.com/991325.
}

// NewAttachToTargetArgs initializes AttachToTargetArgs with the required arguments.
func NewAttachToTargetArgs(targetID ID) *AttachToTargetArgs {
	args := new(AttachToTargetArgs)
	args.TargetID = targetID
	return args
}

// SetFlatten sets the Flatten optional argument. Enables "flat"
// access to the session via specifying sessionId attribute in the
// commands. We plan to make this the default, deprecate non-flattened
// mode, and eventually retire it. See crbug.com/991325.
func (a *AttachToTargetArgs) SetFlatten(flatten bool) *AttachToTargetArgs {
	a.Flatten = &flatten
	return a
}

// AttachToTargetReply represents the return values for AttachToTarget in the Target domain.
type AttachToTargetReply struct {
	SessionID SessionID `json:"sessionId"` // Id assigned to the session.
}

// AttachToBrowserTargetReply represents the return values for AttachToBrowserTarget in the Target domain.
type AttachToBrowserTargetReply struct {
	SessionID SessionID `json:"sessionId"` // Id assigned to the session.
}

// CloseTargetArgs represents the arguments for CloseTarget in the Target domain.
type CloseTargetArgs struct {
	TargetID ID `json:"targetId"` // No description.
}

// NewCloseTargetArgs initializes CloseTargetArgs with the required arguments.
func NewCloseTargetArgs(targetID ID) *CloseTargetArgs {
	args := new(CloseTargetArgs)
	args.TargetID = targetID
	return args
}

// CloseTargetReply represents the return values for CloseTarget in the Target domain.
type CloseTargetReply struct {
	// Success is deprecated.
	//
	// Deprecated: Always set to true. If an error occurs, the response
	// indicates protocol error.
	Success bool `json:"success"`
}

// ExposeDevToolsProtocolArgs represents the arguments for ExposeDevToolsProtocol in the Target domain.
type ExposeDevToolsProtocolArgs struct {
	TargetID    ID      `json:"targetId"`              // No description.
	BindingName *string `json:"bindingName,omitempty"` // Binding name, 'cdp' if not specified.
}

// NewExposeDevToolsProtocolArgs initializes ExposeDevToolsProtocolArgs with the required arguments.
func NewExposeDevToolsProtocolArgs(targetID ID) *ExposeDevToolsProtocolArgs {
	args := new(ExposeDevToolsProtocolArgs)
	args.TargetID = targetID
	return args
}

// SetBindingName sets the BindingName optional argument. Binding
// name, 'cdp' if not specified.
func (a *ExposeDevToolsProtocolArgs) SetBindingName(bindingName string) *ExposeDevToolsProtocolArgs {
	a.BindingName = &bindingName
	return a
}

// CreateBrowserContextArgs represents the arguments for CreateBrowserContext in the Target domain.
type CreateBrowserContextArgs struct {
	DisposeOnDetach                   *bool    `json:"disposeOnDetach,omitempty"`                   // If specified, disposes this context when debugging session disconnects.
	ProxyServer                       *string  `json:"proxyServer,omitempty"`                       // Proxy server, similar to the one passed to --proxy-server
	ProxyBypassList                   *string  `json:"proxyBypassList,omitempty"`                   // Proxy bypass list, similar to the one passed to --proxy-bypass-list
	OriginsWithUniversalNetworkAccess []string `json:"originsWithUniversalNetworkAccess,omitempty"` // An optional list of origins to grant unlimited cross-origin access to. Parts of the URL other than those constituting origin are ignored.
}

// NewCreateBrowserContextArgs initializes CreateBrowserContextArgs with the required arguments.
func NewCreateBrowserContextArgs() *CreateBrowserContextArgs {
	args := new(CreateBrowserContextArgs)

	return args
}

// SetDisposeOnDetach sets the DisposeOnDetach optional argument. If
// specified, disposes this context when debugging session disconnects.
func (a *CreateBrowserContextArgs) SetDisposeOnDetach(disposeOnDetach bool) *CreateBrowserContextArgs {
	a.DisposeOnDetach = &disposeOnDetach
	return a
}

// SetProxyServer sets the ProxyServer optional argument. Proxy
// server, similar to the one passed to --proxy-server
func (a *CreateBrowserContextArgs) SetProxyServer(proxyServer string) *CreateBrowserContextArgs {
	a.ProxyServer = &proxyServer
	return a
}

// SetProxyBypassList sets the ProxyBypassList optional argument.
// Proxy bypass list, similar to the one passed to --proxy-bypass-list
func (a *CreateBrowserContextArgs) SetProxyBypassList(proxyBypassList string) *CreateBrowserContextArgs {
	a.ProxyBypassList = &proxyBypassList
	return a
}

// SetOriginsWithUniversalNetworkAccess sets the OriginsWithUniversalNetworkAccess optional argument.
// An optional list of origins to grant unlimited cross-origin access
// to. Parts of the URL other than those constituting origin are
// ignored.
func (a *CreateBrowserContextArgs) SetOriginsWithUniversalNetworkAccess(originsWithUniversalNetworkAccess []string) *CreateBrowserContextArgs {
	a.OriginsWithUniversalNetworkAccess = originsWithUniversalNetworkAccess
	return a
}

// CreateBrowserContextReply represents the return values for CreateBrowserContext in the Target domain.
type CreateBrowserContextReply struct {
	BrowserContextID internal.BrowserContextID `json:"browserContextId"` // The id of the context created.
}

// GetBrowserContextsReply represents the return values for GetBrowserContexts in the Target domain.
type GetBrowserContextsReply struct {
	BrowserContextIDs []internal.BrowserContextID `json:"browserContextIds"` // An array of browser context ids.
}

// CreateTargetArgs represents the arguments for CreateTarget in the Target domain.
type CreateTargetArgs struct {
	URL    string `json:"url"`              // The initial URL the page will be navigated to. An empty string indicates about:blank.
	Width  *int   `json:"width,omitempty"`  // Frame width in DIP (headless chrome only).
	Height *int   `json:"height,omitempty"` // Frame height in DIP (headless chrome only).
	// BrowserContextID The browser context to create the page in.
	//
	// Note: This property is experimental.
	BrowserContextID *internal.BrowserContextID `json:"browserContextId,omitempty"`
	// EnableBeginFrameControl Whether BeginFrames for this target will be
	// controlled via DevTools (headless chrome only, not supported on
	// MacOS yet, false by default).
	//
	// Note: This property is experimental.
	EnableBeginFrameControl *bool `json:"enableBeginFrameControl,omitempty"`
	NewWindow               *bool `json:"newWindow,omitempty"`  // Whether to create a new Window or Tab (chrome-only, false by default).
	Background              *bool `json:"background,omitempty"` // Whether to create the target in background or foreground (chrome-only, false by default).
}

// NewCreateTargetArgs initializes CreateTargetArgs with the required arguments.
func NewCreateTargetArgs(url string) *CreateTargetArgs {
	args := new(CreateTargetArgs)
	args.URL = url
	return args
}

// SetWidth sets the Width optional argument. Frame width in DIP
// (headless chrome only).
func (a *CreateTargetArgs) SetWidth(width int) *CreateTargetArgs {
	a.Width = &width
	return a
}

// SetHeight sets the Height optional argument. Frame height in DIP
// (headless chrome only).
func (a *CreateTargetArgs) SetHeight(height int) *CreateTargetArgs {
	a.Height = &height
	return a
}

// SetBrowserContextID sets the BrowserContextID optional argument.
// The browser context to create the page in.
//
// Note: This property is experimental.
func (a *CreateTargetArgs) SetBrowserContextID(browserContextID internal.BrowserContextID) *CreateTargetArgs {
	a.BrowserContextID = &browserContextID
	return a
}

// SetEnableBeginFrameControl sets the EnableBeginFrameControl optional argument.
// Whether BeginFrames for this target will be controlled via DevTools
// (headless chrome only, not supported on MacOS yet, false by
// default).
//
// Note: This property is experimental.
func (a *CreateTargetArgs) SetEnableBeginFrameControl(enableBeginFrameControl bool) *CreateTargetArgs {
	a.EnableBeginFrameControl = &enableBeginFrameControl
	return a
}

// SetNewWindow sets the NewWindow optional argument. Whether to
// create a new Window or Tab (chrome-only, false by default).
func (a *CreateTargetArgs) SetNewWindow(newWindow bool) *CreateTargetArgs {
	a.NewWindow = &newWindow
	return a
}

// SetBackground sets the Background optional argument. Whether to
// create the target in background or foreground (chrome-only, false by
// default).
func (a *CreateTargetArgs) SetBackground(background bool) *CreateTargetArgs {
	a.Background = &background
	return a
}

// CreateTargetReply represents the return values for CreateTarget in the Target domain.
type CreateTargetReply struct {
	TargetID ID `json:"targetId"` // The id of the page opened.
}

// DetachFromTargetArgs represents the arguments for DetachFromTarget in the Target domain.
type DetachFromTargetArgs struct {
	SessionID *SessionID `json:"sessionId,omitempty"` // Session to detach.
	// TargetID is deprecated.
	//
	// Deprecated: Deprecated.
	TargetID *ID `json:"targetId,omitempty"`
}

// NewDetachFromTargetArgs initializes DetachFromTargetArgs with the required arguments.
func NewDetachFromTargetArgs() *DetachFromTargetArgs {
	args := new(DetachFromTargetArgs)

	return args
}

// SetSessionID sets the SessionID optional argument. Session to
// detach.
func (a *DetachFromTargetArgs) SetSessionID(sessionID SessionID) *DetachFromTargetArgs {
	a.SessionID = &sessionID
	return a
}

// SetTargetID sets the TargetID optional argument.
//
// Deprecated: Deprecated.
func (a *DetachFromTargetArgs) SetTargetID(targetID ID) *DetachFromTargetArgs {
	a.TargetID = &targetID
	return a
}

// DisposeBrowserContextArgs represents the arguments for DisposeBrowserContext in the Target domain.
type DisposeBrowserContextArgs struct {
	BrowserContextID internal.BrowserContextID `json:"browserContextId"` // No description.
}

// NewDisposeBrowserContextArgs initializes DisposeBrowserContextArgs with the required arguments.
func NewDisposeBrowserContextArgs(browserContextID internal.BrowserContextID) *DisposeBrowserContextArgs {
	args := new(DisposeBrowserContextArgs)
	args.BrowserContextID = browserContextID
	return args
}

// GetTargetInfoArgs represents the arguments for GetTargetInfo in the Target domain.
type GetTargetInfoArgs struct {
	TargetID *ID `json:"targetId,omitempty"` // No description.
}

// NewGetTargetInfoArgs initializes GetTargetInfoArgs with the required arguments.
func NewGetTargetInfoArgs() *GetTargetInfoArgs {
	args := new(GetTargetInfoArgs)

	return args
}

// SetTargetID sets the TargetID optional argument.
func (a *GetTargetInfoArgs) SetTargetID(targetID ID) *GetTargetInfoArgs {
	a.TargetID = &targetID
	return a
}

// GetTargetInfoReply represents the return values for GetTargetInfo in the Target domain.
type GetTargetInfoReply struct {
	TargetInfo Info `json:"targetInfo"` // No description.
}

// GetTargetsReply represents the return values for GetTargets in the Target domain.
type GetTargetsReply struct {
	TargetInfos []Info `json:"targetInfos"` // The list of targets.
}

// SendMessageToTargetArgs represents the arguments for SendMessageToTarget in the Target domain.
type SendMessageToTargetArgs struct {
	Message   string     `json:"message"`             // No description.
	SessionID *SessionID `json:"sessionId,omitempty"` // Identifier of the session.
	// TargetID is deprecated.
	//
	// Deprecated: Deprecated.
	TargetID *ID `json:"targetId,omitempty"`
}

// NewSendMessageToTargetArgs initializes SendMessageToTargetArgs with the required arguments.
func NewSendMessageToTargetArgs(message string) *SendMessageToTargetArgs {
	args := new(SendMessageToTargetArgs)
	args.Message = message
	return args
}

// SetSessionID sets the SessionID optional argument. Identifier of
// the session.
func (a *SendMessageToTargetArgs) SetSessionID(sessionID SessionID) *SendMessageToTargetArgs {
	a.SessionID = &sessionID
	return a
}

// SetTargetID sets the TargetID optional argument.
//
// Deprecated: Deprecated.
func (a *SendMessageToTargetArgs) SetTargetID(targetID ID) *SendMessageToTargetArgs {
	a.TargetID = &targetID
	return a
}

// SetAutoAttachArgs represents the arguments for SetAutoAttach in the Target domain.
type SetAutoAttachArgs struct {
	AutoAttach             bool  `json:"autoAttach"`             // Whether to auto-attach to related targets.
	WaitForDebuggerOnStart bool  `json:"waitForDebuggerOnStart"` // Whether to pause new targets when attaching to them. Use `Runtime.runIfWaitingForDebugger` to run paused targets.
	Flatten                *bool `json:"flatten,omitempty"`      // Enables "flat" access to the session via specifying sessionId attribute in the commands. We plan to make this the default, deprecate non-flattened mode, and eventually retire it. See crbug.com/991325.
}

// NewSetAutoAttachArgs initializes SetAutoAttachArgs with the required arguments.
func NewSetAutoAttachArgs(autoAttach bool, waitForDebuggerOnStart bool) *SetAutoAttachArgs {
	args := new(SetAutoAttachArgs)
	args.AutoAttach = autoAttach
	args.WaitForDebuggerOnStart = waitForDebuggerOnStart
	return args
}

// SetFlatten sets the Flatten optional argument. Enables "flat"
// access to the session via specifying sessionId attribute in the
// commands. We plan to make this the default, deprecate non-flattened
// mode, and eventually retire it. See crbug.com/991325.
func (a *SetAutoAttachArgs) SetFlatten(flatten bool) *SetAutoAttachArgs {
	a.Flatten = &flatten
	return a
}

// AutoAttachRelatedArgs represents the arguments for AutoAttachRelated in the Target domain.
type AutoAttachRelatedArgs struct {
	TargetID               ID   `json:"targetId"`               // No description.
	WaitForDebuggerOnStart bool `json:"waitForDebuggerOnStart"` // Whether to pause new targets when attaching to them. Use `Runtime.runIfWaitingForDebugger` to run paused targets.
}

// NewAutoAttachRelatedArgs initializes AutoAttachRelatedArgs with the required arguments.
func NewAutoAttachRelatedArgs(targetID ID, waitForDebuggerOnStart bool) *AutoAttachRelatedArgs {
	args := new(AutoAttachRelatedArgs)
	args.TargetID = targetID
	args.WaitForDebuggerOnStart = waitForDebuggerOnStart
	return args
}

// SetDiscoverTargetsArgs represents the arguments for SetDiscoverTargets in the Target domain.
type SetDiscoverTargetsArgs struct {
	Discover bool `json:"discover"` // Whether to discover available targets.
}

// NewSetDiscoverTargetsArgs initializes SetDiscoverTargetsArgs with the required arguments.
func NewSetDiscoverTargetsArgs(discover bool) *SetDiscoverTargetsArgs {
	args := new(SetDiscoverTargetsArgs)
	args.Discover = discover
	return args
}

// SetRemoteLocationsArgs represents the arguments for SetRemoteLocations in the Target domain.
type SetRemoteLocationsArgs struct {
	Locations []RemoteLocation `json:"locations"` // List of remote locations.
}

// NewSetRemoteLocationsArgs initializes SetRemoteLocationsArgs with the required arguments.
func NewSetRemoteLocationsArgs(locations []RemoteLocation) *SetRemoteLocationsArgs {
	args := new(SetRemoteLocationsArgs)
	args.Locations = locations
	return args
}
